import sys,pygame,os,math,block
from pygame.locals import *

class Board:
    def __init__(self, bounds):
        self.bounds_x = bounds[0]
        self.bounds_y = bounds[1]
        self.grid_x = bounds[0]/10
        self.grid_y = bounds[1]/10
        self.grid = [ [0 for i in range(self.grid_y)] \
                      for j in range(self.grid_x) ]
        self.current_block = block.generate_block(50, 10)

    def new_block(self):
        self.current_block = block.generate_block(50, 10)
        for x,y in self.current_block.grid_cor():
            if self.grid[x][y] == 1:
                print "you lose"
                sys.exit(0)

    def rotate(self):
        structure = [ (-b,a) for a,b in self.current_block.structure ]
        rot = [ (a+self.current_block.x/10,b+self.current_block.y/10) \
                for a,b in structure ]
        for x,y in rot:
            try:
                if x < 0 or x > len(self.grid[0])-1 or self.grid[x][y] == 1:
                    return
            except IndexError:
                return
        self.current_block.rotate()

    def left(self):
        for x,y in self.current_block.grid_cor():
            if x == 0 or self.grid[x-1][y] == 1: return
        self.current_block.left()

    def right(self):
        for x,y in self.current_block.grid_cor():
            if x == self.grid_x-1: return
            elif x < self.grid_x-1 and self.grid[x+1][y] == 1: return
        self.current_block.right()

    def down(self):
        for x,y in self.current_block.grid_cor():
            if y+1 == self.grid_y or self.grid[x][y+1] == 1:
                for x,y in self.current_block.grid_cor():
                    self.grid[x][y] = 1
                self.new_block()
                self.check_lines()
                return
        self.current_block.down()

    def drop(self):
        block_cols = {}
        for x,y in self.current_block.grid_cor():
            try:
                if block_cols[x][1] < y:
                    block_cols[x] = (x,y)
            except KeyError:
                block_cols[x] = (x,y)

        max_bottoms = {}
        for x in block_cols:
            count = block_cols[x][1]
            for y in range(block_cols[x][1], self.grid_y):
                if self.grid[x][y] == 1:
                    break
                count += 1
            max_bottoms[x] = count

        min_drop = self.grid_y+1
        for x in block_cols:
            dist = max_bottoms[x] - block_cols[x][1] - 1
            if dist < min_drop:
                min_drop = dist
        
        self.current_block.set_grid_y(\
            self.current_block.grid_cor()[0][1] + min_drop)

    def check_lines(self):
        for y in range(self.grid_y):
            count = 0
            for x in range(self.grid_x):
                count += self.grid[x][y]
            if count == self.grid_x:
                for line in self.grid:
                    del(line[y])
                    line.insert(0,0)
            

    def draw(self,screen):
        self.current_block.draw(screen)
        for i in range(self.grid_x):
            for j in range(self.grid_y):
                if self.grid[i][j] == 1:
                    screen.fill((0,255,0), pygame.Rect(i*10,j*10,10,10))

                    
